﻿'//////////////////////////////////////////////////////////////////////////////////////////////////
' 
'  ACT距離計算サービス サンプルプログラム
'  ArrayExtensionMethodsモジュール
'
'  Copyrights (c) 2016 Advanced Core Technologies, Inc. All rights reserved.
'
'  2016/02/12 Rev.1.0.0.0 MOTO 作成
'
'//////////////////////////////////////////////////////////////////////////////////////////////////

Imports System.Runtime.CompilerServices

''' <summary>
''' Arrayクラスの拡張メソッドを定義します。
''' </summary>
Friend Module ArrayExtensionMethods

    ''' <summary>
    ''' 配列のstart番目の要素からlength分の長さのコピーを返します。
    ''' </summary>
    ''' <typeparam name="T">コピーする配列の型</typeparam>
    ''' <param name="source">コピー元の配列</param>
    ''' <param name="start">コピーを開始するインデックス</param>
    ''' <param name="length">コピーする長さ</param>
    ''' <returns>コピーした要素を格納した配列。</returns>
    <Extension()>
    Public Function Copy(Of T)(ByVal source As T(), ByVal start As Integer,
                               ByVal length As Integer) As T()
        If start < 0 OrElse start >= source.Length Then
            Throw New ArgumentOutOfRangeException("start")
        End If
        If (length <= 0 OrElse start + length > source.Length) Then
            Throw New ArgumentException("length")
        End If

        Dim newArray(length - 1) As T
        Array.Copy(source, start, newArray, 0, length)

        Return newArray
    End Function

End Module
